#include <OneWire.h>
#include <DallasTemperature.h>
// wykorzystujemy pin A0 Arduino, więc:
#define SZYNA_1WIRE A0
#define ROZDZIELCZOSC 12 // ustaw 9...12
// najpierw korzystamy z "ogólnej" biblioteki OneWire:
OneWire obiektOneWire(SZYNA_1WIRE);
// i wiążemy ją z obiektem biblioteki DallasTemperature
DallasTemperature czujniki(&obiektOneWire);
int liczbaCzujnikow; //to zmienna dla liczby czujników
//i zmienna typu DeviceAddress na znalezione adresy
DeviceAddress tmpAdresyCzujnikow;

void setup(void)   { //inicjalizacja
 Serial.begin(9600);
 Serial.println("Program testowy termometrow Dallas");
 czujniki.begin(); //sprawdź dołączone czujniki 1Wire
 Serial.println("Wyszukujemy czujniki...");
 liczbaCzujnikow = czujniki.getDeviceCount();
 Serial.print("Znalezione czujniki: ");
 Serial.println(liczbaCzujnikow, DEC);
// sprawdzanie, czy jest zasilanie pasożytnicze
 Serial.print("Zasilanie pasozytnicze jest "); 
 if (czujniki.isParasitePowerMode()) Serial.println("wlaczone");
 else Serial.println("wylaczone");
 Serial.println();
// sprawdzam adresy/numery znalezionych czujników
 for(int i=0;i<liczbaCzujnikow; i++) {
  if(czujniki.getAddress(tmpAdresyCzujnikow, i))  	{
	Serial.print("Znalazlem czujnik "); Serial.print(i, DEC);
	Serial.print(" o adresie "); 
	drukujAdres(tmpAdresyCzujnikow); Serial.println();
	Serial.print("i ustawiam jego rozdzielczosc na ");
	Serial.print(ROZDZIELCZOSC, DEC); Serial.println(" bitow.");
	czujniki.setResolution(tmpAdresyCzujnikow, ROZDZIELCZOSC);
  Serial.print("Sprawdzilem, ze rozdzielczosc wynosi ");
	Serial.print(czujniki.getResolution(tmpAdresyCzujnikow), DEC); 
	Serial.println(" bitow."); Serial.println();
	}else{ Serial.print("Znalazlem dziwne urządzenie numer ");
	Serial.print(i, DEC);
	Serial.print(" ale nie moge odczytac adresu/numeru.");} } }
 
// oddzielna funkcja do wypisania temperatury na ekranie
void drukujTemperature(DeviceAddress adres) {
/* niewykorzystana metoda 1  - wolniejsza
  //Serial.print("Temp C: ");
  //Serial.print(czujniki.getTempC(adres));
  //Serial.print(" Temp F: ");
  //Serial.print(czujniki.getTempF(adres));
   // metoda 2 - szybsza
  float tempC = czujniki.getTempC(adres);
  Serial.print("Temp C: ");   Serial.print(tempC);
  Serial.print(" Temp F: ");
  Serial.println(DallasTemperature::toFahrenheit(tempC)); */
 float tempC = czujniki.getTempC(adres); 
 Serial.print(tempC); Serial.print("\xC2\xB0"); Serial.print("C "); }

void loop(void)  {  //rozkaz do wszystkich czujników:
  czujniki.requestTemperatures(); Serial.println();
//potem dla każdego czujnika wypisz jego temperaturę
  for(int i=0;i<liczbaCzujnikow; i++)
  { // najpierw odczytaj adres kolejnego czujnika
    if(czujniki.getAddress(tmpAdresyCzujnikow, i))
	{ // i podaj wynik pomiaru
	Serial.print("Czujnik ");
	Serial.print(i,DEC); Serial.print(": ");
//wykorzystujemy funkcję drukujTemperature
	drukujTemperature(tmpAdresyCzujnikow);  }  }
  delay(10000); } // czekaj 10 sekund

// funkcja wypisująca na ekranie adres
void drukujAdres(DeviceAddress adresik) {
  for (uint8_t i = 0; i < 8; i++)   {
    if (adresik[i] < 16) Serial.print("0");
    Serial.print(adresik[i], HEX); } }
